diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-mac.h ns-3.42/src/wifi/model/wifi-mac.h
--- ns-3.41/src/wifi/model/wifi-mac.h	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-mac.h	2024-05-29 15:29:47.212073800 -0700
@@ -26,6 +26,8 @@
 #include "wifi-remote-station-manager.h"
 #include "wifi-standards.h"
 
+#include "ns3/uniform-random-bit-generator.h"
+
 #include <functional>
 #include <list>
 #include <map>
@@ -55,6 +57,7 @@
 class ExtendedCapabilities;
 class OriginatorBlockAckAgreement;
 class RecipientBlockAckAgreement;
+class UniformRandomVariable;
 
 /**
  * \ingroup wifi
@@ -109,6 +112,17 @@
     WifiMac& operator=(const WifiMac&) = delete;
 
     /**
+     * Assign a fixed random variable stream number to the random variables
+     * used by this model.  Return the number of streams (possibly zero) that
+     * have been assigned.
+     *
+     * \param stream first stream index to use
+     *
+     * \return the number of stream indices assigned by this model
+     */
+    virtual int64_t AssignStreams(int64_t stream);
+
+    /**
      * Sets the device this PHY is associated with.
      *
      * \param device the device this PHY is associated with
@@ -130,6 +144,11 @@
     Ptr<FrameExchangeManager> GetFrameExchangeManager(uint8_t linkId = SINGLE_LINK_OP_ID) const;
 
     /**
+     * \param feManagers the frame exchange managers attached to this MAC.
+     */
+    void SetFrameExchangeManagers(const std::vector<Ptr<FrameExchangeManager>>& feManagers);
+
+    /**
      * Get the Channel Access Manager associated with the given link
      *
      * \param linkId the ID of the given link
@@ -138,6 +157,11 @@
     Ptr<ChannelAccessManager> GetChannelAccessManager(uint8_t linkId = SINGLE_LINK_OP_ID) const;
 
     /**
+     * \param caManagers the channel access managers attached to this MAC.
+     */
+    void SetChannelAccessManagers(const std::vector<Ptr<ChannelAccessManager>>& caManagers);
+
+    /**
      * Get the number of links (can be greater than 1 for 11be devices only).
      *
      * \return the number of links used by this MAC
@@ -174,6 +198,14 @@
     std::optional<uint8_t> GetLinkForPhy(std::size_t phyId) const;
 
     /**
+     * Indicate if a given link is on the 6 GHz band.
+     *
+     * \param linkId the ID of the given link
+     * \return whether the given link is on the 6 GHz band
+     */
+    bool Is6GhzBand(uint8_t linkId) const;
+
+    /**
      * \param remoteAddr the (MLD or link) address of a remote device
      * \return the MLD address of the remote device having the given (MLD or link) address, if
      *         the remote device is an MLD.
@@ -468,16 +500,6 @@
     void NotifyRxDrop(Ptr<const Packet> packet);
 
     /**
-     * \param standard the wifi standard to be configured
-     *
-     * This method completes the configuration process for a requested PHY standard
-     * by creating the Frame Exchange Manager and the Channel Access Manager and
-     * configuring the PHY dependent parameters.
-     * This method can only be called after a configured PHY has been set.
-     */
-    virtual void ConfigureStandard(WifiStandard standard);
-
-    /**
      * \return pointer to HtConfiguration if it exists
      */
     Ptr<HtConfiguration> GetHtConfiguration() const;
@@ -522,6 +544,13 @@
      */
     HeCapabilities GetHeCapabilities(uint8_t linkId) const;
     /**
+     * Return the HE 6GHz band capabilities of the device for the given 6 GHz link.
+     *
+     * \param linkId the ID of the given 6 GHz link
+     * \return the HE 6GHz band capabilities that we support
+     */
+    He6GhzBandCapabilities GetHe6GhzBandCapabilities(uint8_t linkId) const;
+    /**
      * Return the EHT capabilities of the device for the given link.
      *
      * \param linkId the ID of the given link
@@ -550,11 +579,12 @@
      */
     bool GetDsssSupported(uint8_t linkId) const;
     /**
-     * Return whether the device supports HT.
+     * Return whether the device supports HT on the given link.
      *
+     * \param linkId the ID of the given link.
      * \return true if HT is supported, false otherwise
      */
-    bool GetHtSupported() const;
+    bool GetHtSupported(uint8_t linkId) const;
     /**
      * Return whether the device supports VHT on the given link.
      *
@@ -730,6 +760,7 @@
   protected:
     void DoInitialize() override;
     void DoDispose() override;
+    void NotifyConstructionCompleted() override;
 
     /**
      * \param cwMin the minimum contention window size
@@ -741,15 +772,6 @@
     virtual void ConfigureContentionWindow(uint32_t cwMin, uint32_t cwMax);
 
     /**
-     * Enable or disable QoS support for the device. Construct a Txop object
-     * or QosTxop objects accordingly. This method can only be called before
-     * initialization.
-     *
-     * \param enable whether QoS is supported
-     */
-    void SetQosSupported(bool enable);
-
-    /**
      * Enable or disable short slot time feature.
      *
      * \param enable true if short slot time is to be supported,
@@ -899,6 +921,16 @@
 
   private:
     /**
+     * Complete the configuration of the MAC layer components.
+     */
+    void CompleteConfig();
+
+    /**
+     * Allow subclasses to complete the configuration of the MAC layer components.
+     */
+    virtual void DoCompleteConfig() = 0;
+
+    /**
      * \param dcf the DCF to be configured
      * \param cwmin the minimum contention window for the DCF
      * \param cwmax the maximum contention window for the DCF
@@ -921,6 +953,60 @@
     void ConfigurePhyDependentParameters(uint8_t linkId);
 
     /**
+     * Enable or disable QoS support for the device. Construct a Txop object or QosTxop objects
+     * accordingly. This method is private so that it is only used while constructing this object.
+     *
+     * \param enable whether QoS is supported
+     */
+    void SetQosSupported(bool enable);
+
+    /**
+     * Set the Txop object.
+     * This method is private so that it is only used while constructing this object.
+     *
+     * \param dcf the Txop object
+     */
+    void SetTxop(Ptr<Txop> dcf);
+
+    /**
+     * Set the AC_VO channel access function
+     * This method is private so that it is only used while constructing this object.
+     *
+     * \param edca the QosTxop object for AC_VO
+     */
+    void SetVoQueue(Ptr<QosTxop> edca);
+
+    /**
+     * Set the AC_VI channel access function
+     * This method is private so that it is only used while constructing this object.
+     *
+     * \param edca the QosTxop object for AC_VI
+     */
+    void SetViQueue(Ptr<QosTxop> edca);
+
+    /**
+     * Set the AC_BE channel access function
+     * This method is private so that it is only used while constructing this object.
+     *
+     * \param edca the QosTxop object for AC_BE
+     */
+    void SetBeQueue(Ptr<QosTxop> edca);
+
+    /**
+     * Set the AC_BK channel access function
+     * This method is private so that it is only used while constructing this object.
+     *
+     * \param edca the QosTxop object for AC_BK
+     */
+    void SetBkQueue(Ptr<QosTxop> edca);
+
+    /**
+     * This method is a private utility invoked to configure the channel
+     * access function for devices that do not support QoS.
+     */
+    void SetupDcfQueue();
+
+    /**
      * This method is a private utility invoked to configure the channel
      * access function for the specified Access Category.
      *
@@ -929,13 +1015,12 @@
     void SetupEdcaQueue(AcIndex ac);
 
     /**
-     * Create a Frame Exchange Manager depending on the supported version
-     * of the standard.
+     * If no link has been already created, create the given number links; otherwise, do nothing.
      *
-     * \param standard the supported version of the standard
-     * \return the created Frame Exchange Manager
+     * \param nLinks the given number of links
+     * \return whether the given number of links have been created
      */
-    Ptr<FrameExchangeManager> SetupFrameExchangeManager(WifiStandard standard);
+    bool CreateLinksIfNeeded(std::size_t nLinks);
 
     /**
      * Create a LinkEntity object.
@@ -1077,6 +1162,8 @@
 
     uint16_t m_mpduBufferSize; //!< BlockAck buffer size (in number of MPDUs)
 
+    UniformRandomBitGenerator m_shuffleLinkIdsGen; //!< random number generator to shuffle link IDs
+
     /// @brief DL TID-to-Link Mapping negotiated with an MLD (identified by its MLD address)
     std::unordered_map<Mac48Address, WifiTidLinkMapping, WifiAddressHash> m_dlTidLinkMappings;
     /// @brief UL TID-to-Link Mapping negotiated with an MLD (identified by its MLD address)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-mac-header.cc ns-3.42/src/wifi/model/wifi-mac-header.cc
--- ns-3.41/src/wifi/model/wifi-mac-header.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-mac-header.cc	2024-05-29 15:29:47.212073800 -0700
@@ -1156,12 +1156,6 @@
     case WIFI_MAC_MGT_PROBE_RESPONSE:
     case WIFI_MAC_MGT_AUTHENTICATION:
     case WIFI_MAC_MGT_DEAUTHENTICATION:
-        PrintFrameControl(os);
-        os << " Duration/ID=" << m_duration << "us"
-           << ", DA=" << m_addr1 << ", SA=" << m_addr2 << ", BSSID=" << m_addr3
-           << ", FragNumber=" << std::hex << (int)m_seqFrag << std::dec
-           << ", SeqNumber=" << m_seqSeq;
-        break;
     case WIFI_MAC_MGT_ACTION:
     case WIFI_MAC_MGT_ACTION_NO_ACK:
         PrintFrameControl(os);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-mac-queue.cc ns-3.42/src/wifi/model/wifi-mac-queue.cc
--- ns-3.41/src/wifi/model/wifi-mac-queue.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-mac-queue.cc	2024-05-29 15:29:47.212073800 -0700
@@ -130,7 +130,8 @@
     for (const auto& mpdu : mpdus)
     {
         // fire the Expired trace
-        Simulator::ScheduleNow(&WifiMacQueue::m_traceExpired, this, mpdu);
+        auto fire = [this, mpdu]() -> void { this->m_traceExpired(mpdu); };
+        Simulator::ScheduleNow(fire);
     }
     // notify the scheduler
     if (!mpdus.empty())
@@ -154,7 +155,8 @@
     for (const auto& mpdu : mpdus)
     {
         // fire the Expired trace
-        Simulator::ScheduleNow(&WifiMacQueue::m_traceExpired, this, mpdu);
+        auto fire = [this, mpdu]() -> void { this->m_traceExpired(mpdu); };
+        Simulator::ScheduleNow(fire);
     }
     // notify the scheduler
     if (!mpdus.empty())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-mac-queue-container.cc ns-3.42/src/wifi/model/wifi-mac-queue-container.cc
--- ns-3.41/src/wifi/model/wifi-mac-queue-container.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-mac-queue-container.cc	2024-05-29 15:29:47.212073800 -0700
@@ -25,6 +25,8 @@
 #include "ns3/mac48-address.h"
 #include "ns3/simulator.h"
 
+#include <vector>
+
 namespace ns3
 {
 
@@ -209,14 +211,14 @@
     auto [type, addrType, address, tid] = queueId;
     const std::size_t size = tid.has_value() ? 8 : 7;
 
-    uint8_t buffer[size];
+    std::vector<uint8_t> buffer(size);
     buffer[0] = type;
-    address.CopyTo(buffer + 1);
+    address.CopyTo(&buffer[1]);
     if (tid.has_value())
     {
         buffer[7] = *tid;
     }
 
-    std::string s(buffer, buffer + size);
+    std::string s(buffer.begin(), buffer.end());
     return std::hash<std::string>{}(s);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-mac-queue-scheduler.h ns-3.42/src/wifi/model/wifi-mac-queue-scheduler.h
--- ns-3.41/src/wifi/model/wifi-mac-queue-scheduler.h	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-mac-queue-scheduler.h	2024-05-29 15:29:47.212073800 -0700
@@ -135,9 +135,13 @@
      *
      * \param ac the given Access Category
      * \param mpdu the given MPDU
+     * \param ignoredReasons list of reasons for blocking a link that are ignored
      * \return the list of the IDs of the links the given MPDU can be sent over
      */
-    virtual std::list<uint8_t> GetLinkIds(AcIndex ac, Ptr<const WifiMpdu> mpdu) = 0;
+    virtual std::list<uint8_t> GetLinkIds(
+        AcIndex ac,
+        Ptr<const WifiMpdu> mpdu,
+        const std::list<WifiQueueBlockedReason>& ignoredReasons = {}) = 0;
 
     /**
      * Block the given set of links for the container queues of the given types and
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-mac-queue-scheduler-impl.h ns-3.42/src/wifi/model/wifi-mac-queue-scheduler-impl.h
--- ns-3.41/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2024-05-29 15:29:47.212073800 -0700
@@ -26,9 +26,11 @@
 
 #include <algorithm>
 #include <functional>
+#include <iterator>
 #include <list>
 #include <map>
 #include <numeric>
+#include <sstream>
 #include <unordered_map>
 #include <vector>
 
@@ -77,7 +79,9 @@
                                                 std::optional<uint8_t> linkId,
                                                 const WifiContainerQueueId& prevQueueId) final;
     /** \copydoc ns3::WifiMacQueueScheduler::GetLinkIds */
-    std::list<uint8_t> GetLinkIds(AcIndex ac, Ptr<const WifiMpdu> mpdu) final;
+    std::list<uint8_t> GetLinkIds(AcIndex ac,
+                                  Ptr<const WifiMpdu> mpdu,
+                                  const std::list<WifiQueueBlockedReason>& ignoredReasons) final;
     /** \copydoc ns3::WifiMacQueueScheduler::BlockQueues */
     void BlockQueues(WifiQueueBlockedReason reason,
                      AcIndex ac,
@@ -444,14 +448,23 @@
 
 template <class Priority, class Compare>
 std::list<uint8_t>
-WifiMacQueueSchedulerImpl<Priority, Compare>::GetLinkIds(AcIndex ac, Ptr<const WifiMpdu> mpdu)
+WifiMacQueueSchedulerImpl<Priority, Compare>::GetLinkIds(
+    AcIndex ac,
+    Ptr<const WifiMpdu> mpdu,
+    const std::list<WifiQueueBlockedReason>& ignoredReasons)
 {
     auto queueInfoIt = InitQueueInfo(ac, mpdu);
     std::list<uint8_t> linkIds;
 
     // include only links that are not blocked in the returned list
-    for (const auto& [linkId, mask] : queueInfoIt->second.linkIds)
+    for (auto [linkId, mask] : queueInfoIt->second.linkIds)
     {
+        // reset the bits of the mask corresponding to the reasons to ignore
+        for (const auto reason : ignoredReasons)
+        {
+            mask.reset(static_cast<std::size_t>(reason));
+        }
+
         if (mask.none())
         {
             linkIds.emplace_back(linkId);
@@ -473,7 +486,12 @@
     const std::set<uint8_t>& tids,
     const std::set<uint8_t>& linkIds)
 {
-    NS_LOG_FUNCTION(this << block << reason << ac << rxAddress << txAddress);
+    std::stringstream ss;
+    if (g_log.IsEnabled(ns3::LOG_FUNCTION))
+    {
+        std::copy(linkIds.cbegin(), linkIds.cend(), std::ostream_iterator<uint16_t>(ss, " "));
+    }
+    NS_LOG_FUNCTION(this << block << reason << ac << rxAddress << txAddress << ss.str());
     std::list<WifiMacHeader> headers;
 
     for (const auto queueType : types)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-mgt-header.h ns-3.42/src/wifi/model/wifi-mgt-header.h
--- ns-3.41/src/wifi/model/wifi-mgt-header.h	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-mgt-header.h	2024-05-29 15:29:47.212073800 -0700
@@ -325,9 +325,9 @@
                                                          to the Per-STA Profile subelement */
 };
 
-/**
- * Implementation of the templates declared above.
- */
+//
+// Implementation of the templates declared above.
+//
 
 template <typename Derived, typename... Elems>
 template <typename T, std::enable_if_t<(std::is_same_v<std::vector<T>, Elems> + ...) == 0, int>>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-net-device.cc ns-3.42/src/wifi/model/wifi-net-device.cc
--- ns-3.41/src/wifi/model/wifi-net-device.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-net-device.cc	2024-05-29 15:29:47.212073800 -0700
@@ -254,6 +254,7 @@
 {
     m_phys.clear();
     m_phys.push_back(phy);
+    phy->SetPhyId(0);
     m_linkUp = true;
     CompleteConfig();
 }
@@ -264,6 +265,10 @@
     NS_ABORT_MSG_IF(phys.size() > 1 && !m_ehtConfiguration,
                     "Multiple PHYs only allowed for 11be multi-link devices");
     m_phys = phys;
+    for (std::size_t id = 0; id < phys.size(); ++id)
+    {
+        m_phys.at(id)->SetPhyId(id);
+    }
     m_linkUp = true;
     CompleteConfig();
 }
@@ -478,17 +483,7 @@
 WifiNetDevice::Send(Ptr<Packet> packet, const Address& dest, uint16_t protocolNumber)
 {
     NS_LOG_FUNCTION(this << packet << dest << protocolNumber);
-    NS_ASSERT(Mac48Address::IsMatchingType(dest));
-
-    Mac48Address realTo = Mac48Address::ConvertFrom(dest);
-
-    LlcSnapHeader llc;
-    llc.SetType(protocolNumber);
-    packet->AddHeader(llc);
-
-    m_mac->NotifyTx(packet);
-    m_mac->Enqueue(packet, realTo);
-    return true;
+    return DoSend(packet, std::nullopt, dest, protocolNumber);
 }
 
 Ptr<Node>
@@ -579,18 +574,41 @@
                         uint16_t protocolNumber)
 {
     NS_LOG_FUNCTION(this << packet << source << dest << protocolNumber);
-    NS_ASSERT(Mac48Address::IsMatchingType(dest));
-    NS_ASSERT(Mac48Address::IsMatchingType(source));
+    return DoSend(packet, source, dest, protocolNumber);
+}
 
-    Mac48Address realTo = Mac48Address::ConvertFrom(dest);
-    Mac48Address realFrom = Mac48Address::ConvertFrom(source);
+bool
+WifiNetDevice::DoSend(Ptr<Packet> packet,
+                      std::optional<Address> source,
+                      const Address& dest,
+                      uint16_t protocolNumber)
+{
+    NS_LOG_FUNCTION(this << packet << dest << protocolNumber << source.value_or(Address()));
+
+    if (source)
+    {
+        NS_ASSERT_MSG(Mac48Address::IsMatchingType(*source),
+                      *source << " is not compatible with a Mac48Address");
+    }
+    NS_ASSERT_MSG(Mac48Address::IsMatchingType(dest),
+                  dest << " is not compatible with a Mac48Address");
+
+    auto realTo = Mac48Address::ConvertFrom(dest);
 
     LlcSnapHeader llc;
     llc.SetType(protocolNumber);
     packet->AddHeader(llc);
 
     m_mac->NotifyTx(packet);
-    m_mac->Enqueue(packet, realTo, realFrom);
+    if (source)
+    {
+        auto realFrom = Mac48Address::ConvertFrom(*source);
+        m_mac->Enqueue(packet, realTo, realFrom);
+    }
+    else
+    {
+        m_mac->Enqueue(packet, realTo);
+    }
 
     return true;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-net-device.h ns-3.42/src/wifi/model/wifi-net-device.h
--- ns-3.41/src/wifi/model/wifi-net-device.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-net-device.h	2024-05-29 15:29:47.212073800 -0700
@@ -25,6 +25,7 @@
 #include "ns3/net-device.h"
 #include "ns3/traced-callback.h"
 
+#include <optional>
 #include <vector>
 
 namespace ns3
@@ -239,6 +240,20 @@
      */
     void CompleteConfig();
 
+    /**
+     * Send a packet
+     *
+     * \param packet packet sent from upper layers
+     * \param source source mac address (if provided)
+     * \param dest destination mac address
+     * \param protocolNumber type of payload contained in this packet
+     * \returns true if successful, false otherwise
+     */
+    bool DoSend(Ptr<Packet> packet,
+                std::optional<Address> source,
+                const Address& dest,
+                uint16_t protocolNumber);
+
     Ptr<Node> m_node;                                             //!< the node
     std::vector<Ptr<WifiPhy>> m_phys;                             //!< the phy objects
     Ptr<WifiMac> m_mac;                                           //!< the MAC
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-opt-field.h ns-3.42/src/wifi/model/wifi-opt-field.h
--- ns-3.41/src/wifi/model/wifi-opt-field.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/wifi/model/wifi-opt-field.h	2024-05-29 15:29:47.212073800 -0700
@@ -0,0 +1,199 @@
+/*
+ * Copyright (c) 2024 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_OPT_FIELD_H
+#define WIFI_OPT_FIELD_H
+
+#include <functional>
+#include <optional>
+
+namespace ns3
+{
+
+/**
+ * \ingroup wifi
+ *
+ * OptFieldWithPresenceInd is a class modeling an optional field (in an Information Element, a
+ * management frame, etc.) having an associated Presence Indicator bit. This class is a wrapper
+ * around std::optional (most of its functions are exposed, more can be added if needed) that
+ * additionally sets the Presence Indicator flag appropriately when operations like reset or
+ * assignment of a value are performed on the optional field.
+ */
+template <typename T>
+class OptFieldWithPresenceInd
+{
+  public:
+    /// @brief constructor
+    /// @param presenceFlag the Presence Indicator flag
+    OptFieldWithPresenceInd(bool& presenceFlag);
+
+    /// @brief Destroy the value (if any) contained in the optional field.
+    /// @return a reference to this object
+    constexpr OptFieldWithPresenceInd& operator=(std::nullopt_t);
+
+    /// @brief Assign the given value to the optional field
+    /// @param other the given value
+    /// @return a reference to this object
+    constexpr OptFieldWithPresenceInd& operator=(const std::optional<T>& other);
+
+    /// @brief Assign the given value to the optional field
+    /// @param other the given value
+    /// @return a reference to this object
+    constexpr OptFieldWithPresenceInd& operator=(std::optional<T>&& other);
+
+    /// @brief Operator bool
+    /// @return whether this object contains a value
+    constexpr explicit operator bool() const;
+
+    /// @brief Check whether this object contains a value
+    /// @return whether this object contains a value
+    constexpr bool has_value() const;
+
+    /// @return a pointer to the contained value
+    constexpr const T* operator->() const;
+
+    /// @return a pointer to the contained value
+    constexpr T* operator->();
+
+    /// @return a reference to the contained value
+    constexpr const T& operator*() const;
+
+    /// @return a reference to the contained value
+    constexpr T& operator*();
+
+    /// @brief Construct the contained value in-place
+    /// @tparam Args the type of arguments to pass to the constructor
+    /// @param args the arguments to pass to the constructor
+    /// @return a reference to the new contained value
+    template <class... Args>
+    constexpr T& emplace(Args&&... args);
+
+    /// @brief Destroy the value (if any) contained in the optional field
+    constexpr void reset();
+
+  private:
+    std::optional<T> m_field;                    ///< the optional field
+    std::reference_wrapper<bool> m_presenceFlag; ///< the Presence Indicator flag
+};
+
+} // namespace ns3
+
+/***************************************************************
+ *  Implementation of the templates declared above.
+ ***************************************************************/
+
+namespace ns3
+{
+
+template <typename T>
+OptFieldWithPresenceInd<T>::OptFieldWithPresenceInd(bool& presenceFlag)
+    : m_presenceFlag(presenceFlag)
+{
+    m_presenceFlag.get() = false;
+}
+
+template <typename T>
+constexpr OptFieldWithPresenceInd<T>&
+OptFieldWithPresenceInd<T>::operator=(std::nullopt_t)
+{
+    m_field.reset();
+    m_presenceFlag.get() = false;
+    return *this;
+}
+
+template <typename T>
+constexpr OptFieldWithPresenceInd<T>&
+OptFieldWithPresenceInd<T>::operator=(const std::optional<T>& other)
+{
+    m_field = other;
+    m_presenceFlag.get() = other.has_value();
+    return *this;
+}
+
+template <typename T>
+constexpr OptFieldWithPresenceInd<T>&
+OptFieldWithPresenceInd<T>::operator=(std::optional<T>&& other)
+{
+    m_field = std::move(other);
+    m_presenceFlag.get() = other.has_value();
+    return *this;
+}
+
+template <typename T>
+constexpr OptFieldWithPresenceInd<T>::operator bool() const
+{
+    return m_field.has_value();
+}
+
+template <typename T>
+constexpr bool
+OptFieldWithPresenceInd<T>::has_value() const
+{
+    return m_field.has_value();
+}
+
+template <typename T>
+constexpr const T*
+OptFieldWithPresenceInd<T>::operator->() const
+{
+    return &(*m_field);
+}
+
+template <typename T>
+constexpr T*
+OptFieldWithPresenceInd<T>::operator->()
+{
+    return &(*m_field);
+}
+
+template <typename T>
+constexpr const T&
+OptFieldWithPresenceInd<T>::operator*() const
+{
+    return *m_field;
+}
+
+template <typename T>
+constexpr T&
+OptFieldWithPresenceInd<T>::operator*()
+{
+    return *m_field;
+}
+
+template <typename T>
+template <class... Args>
+constexpr T&
+OptFieldWithPresenceInd<T>::emplace(Args&&... args)
+{
+    m_field.emplace(std::forward<Args>(args)...);
+    m_presenceFlag.get() = true;
+    return *m_field;
+}
+
+template <typename T>
+constexpr void
+OptFieldWithPresenceInd<T>::reset()
+{
+    m_field.reset();
+    m_presenceFlag.get() = false;
+}
+
+} // namespace ns3
+
+#endif /* WIFI_OPT_FIELD_H */
